<template>
  <div class="app-container">
    <el-row :gutter="20">
      <el-col :span="4" :xs="24">
        <div class="head-container">
          <el-input v-model="deptName" placeholder="请输入部门名称" clearable size="small" prefix-icon="el-icon-search"
            style="margin-bottom: 20px" />
        </div>
        <div class="head-container">
          <el-tree :data="deptOptions" :props="defaultProps" :expand-on-click-node="false"
            :filter-node-method="filterNode" ref="tree" node-key="id" default-expand-all highlight-current
            @node-click="handleNodeClick" />
        </div>
      </el-col>
      <el-col :span="20" :xs="24">
        <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="88px">
          <!-- <el-form-item label="岗位编码" prop="postCode">
            <el-input v-model="queryParams.postCode" placeholder="请输入岗位编码" clearable @keyup.enter.native="handleQuery" />
          </el-form-item> -->
          <el-form-item label="岗位名称" prop="postName">
            <el-input v-model="queryParams.postName" placeholder="请输入岗位名称" clearable @keyup.enter.native="handleQuery" />
          </el-form-item>
          <!-- <el-form-item label="状态" prop="status">
            <el-select v-model="queryParams.status" placeholder="岗位状态" clearable>
              <el-option v-for="dict in dict.type.sys_normal_disable" :key="dict.value" :label="dict.label"
                :value="dict.value" />
            </el-select>
          </el-form-item> -->
          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
              v-hasPermi="['system:post:add']">新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
              v-hasPermi="['system:post:edit']">修改</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
              v-hasPermi="['system:post:remove']">删除</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="primary" plain  size="mini"
              v-hasPermi="['system:post:add']"  @click="importWen = true">导入</el-button>
          </el-col>
          <el-col :span="1.5">
            <!-- <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['system:post:export']"
        >导出</el-button> -->
          </el-col>
          <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <el-table v-loading="loading" :data="postList" @selection-change="handleSelectionChange">
          <el-table-column type="selection" show-overflow-tooltip align="center" />
          <!-- <el-table-column label="岗位编号" show-overflow-tooltip align="center" prop="postId" />
          <el-table-column label="岗位编码" show-overflow-tooltip align="center" prop="postCode" /> -->
          <el-table-column label="岗位名称" show-overflow-tooltip align="center" prop="postName" />
          <el-table-column label="岗位级别" show-overflow-tooltip align="center" prop="postLevel">
            <template slot-scope="scope">
              <span>{{ postLevel(scope.row.postLevel) }}</span>
            </template>
          </el-table-column>

          <el-table-column label="是否关键岗位" align="center" prop="createTime" show-overflow-tooltip>
            <template slot-scope="scope">
              <el-tag>{{ scope.row.importantType===1?"是":"否" }}</el-tag>
            </template>
          </el-table-column>

<!--

          <el-table-column label="状态" align="center" prop="status" width="100" >
            <template slot-scope="scope">
              <dict-tag :options="dict.type.sys_normal_disable" :value="scope.row.status" />
            </template>
          </el-table-column>
-->

          <el-table-column label="岗位排序" align="center" prop="postSort" width="100" />

          <el-table-column label="创建时间" align="center" prop="createTime" show-overflow-tooltip>
            <template slot-scope="scope">
              <span>{{ parseTime(scope.row.createTime) }}</span>
            </template>
          </el-table-column>

          <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="120">
            <template slot-scope="scope">
              <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                v-hasPermi="['system:post:edit']">修改</el-button>
              <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                v-hasPermi="['system:post:remove']">删除</el-button>
            </template>
          </el-table-column>
        </el-table>

        <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
          @pagination="getList" />
      </el-col>
    </el-row>

    <!-- 添加或修改岗位对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="550px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="岗位名称" prop="postName">
          <el-input v-model="form.postName" placeholder="请输入岗位名称" />
        </el-form-item>
        <!--
        <el-form-item label="岗位编码" prop="postCode">
          <el-input v-model="form.postCode" placeholder="请输入编码名称" />
        </el-form-item>
        -->
        <el-form-item label="岗位级别" prop="postLevel">
          <el-select v-model="form.postLevel">
            <el-option v-for="(item, k) in postLevelData" :key="k" :label="item.label" :value="item.value"></el-option>
          </el-select>
        </el-form-item>


        <el-form-item label="是否关键岗位" prop="importantType">
          <el-radio-group v-model="form.importantType">
            <el-radio v-for="dict in importantTypeArr" :key="dict.value" :label="dict.value">{{ dict.label
              }}</el-radio>
          </el-radio-group>
        </el-form-item>

<!--

        <el-form-item label="岗位状态" prop="status">
          <el-radio-group v-model="form.status">
            <el-radio v-for="dict in dict.type.sys_normal_disable" :key="dict.value" :label="dict.value">{{ dict.label
            }}</el-radio>
          </el-radio-group>
        </el-form-item>
-->

        <el-form-item label="岗位顺序" prop="postSort">
          <el-input-number v-model="form.postSort" controls-position="right" :min="0" />
        </el-form-item>


        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

      <!-- 导入文件 -->
      <el-dialog
      v-dialogDrag
      v-loading="loading"
      v-if="importWen"
      title="批量导入"
      :visible.sync="importWen"
      width="40%"
      :close-on-click-modal="false"
      :before-close="cancelCredent"
    >
      <el-row>
        <el-col :span="24">
          <el-form :inline="true" label-position="right" label-width="200px">
            <el-form-item label="导入文件：">
              <el-upload
                ref="upload"
                drag
                class="upload-demo"
                :action="uploadFileUrl"
                multiple
                :limit="2"
                accept=".xls, .xlsx"
                :file-list="fileList"
                :before-upload="beforeUpload"
                :on-success="uploadHttpRequest1"
                :on-remove="removeContractAttachment"
              >
                <i class="el-icon-upload" />
                <div class="el-upload__text">
                  将文件拖到此处，或<em>点击上传</em>
                </div>
              </el-upload>
            </el-form-item>
          </el-form>
        </el-col>
      </el-row>
      <el-row>
        <span
          class="download"
          style="
            cursor: pointer;
            width: 100px;
            margin-left: 200px;
            color: #0c80ea;
          "
          @click="handleDown(`/template/EHR导出岗位人员关系表-模板.xlsx`)"
          >下载模板</span
        >
      </el-row>
      <div style="margin-top: 20px; margin-left: 200px; color: #c7bd78">
        提示:请先按照导出模版文件填写后进行上传
      </div>
      <el-row style="text-align: right; margin-top: 50px; padding-top: 10px">
        <el-button @click="cancelCredent"> 取消 </el-button>
        <el-button
          style="margin-right: 10px"
          type="primary"
          @click="confirmCredent"
        >
          确定
        </el-button>
      </el-row>
    </el-dialog>
  </div>
</template>

<script>
import {
  listPost,
  getPost,
  delPost,
  addPost,
  updatePost
} from '@/api/system/post'

import {
  getBase64,
  upload,
  systemBatchImport
} from '@/api/allApi/index.js'
import { deptTreeSelect } from '@/api/system/user'
export default {
  name: 'Post',
  dicts: ['sys_normal_disable'],
  data() {
    return {
      importWen: false,
      fileList: [],
      uploadList:[],
      whiteList: ['xlsx', 'xls'],
      uploadFileUrl: this.getBaseUrl() + "/common/upload",
      // 文件预览
      previewAnnex: false,
      previewUrl: '',
      previewType: '',
      filename: '',

      deptName: '',
      // 部门树选项
      deptOptions: undefined,
      defaultProps: {
        children: 'children',
        label: 'label'
      },
      postLevelData: [
        {
          value: 0,
          label: '员工'
        },
        {
          value: 1,
          label: '经理'
        },{
          value: 2,
          label: '领导'
        }
      ],
      importantTypeArr: [
        {
          value: 1,
          label: '是'
        },
        {
          value: 2,
          label: '否'
        },
      ],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 岗位表格数据
      postList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        postCode: undefined,
        postName: undefined,
        status: undefined,
        deptId: undefined
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        postName: [
          { required: true, message: '岗位名称不能为空', trigger: 'blur' }
        ],
        postCode: [
          { required: true, message: '岗位编码不能为空', trigger: 'blur' }
        ],
        postSort: [
          { required: true, message: '岗位顺序不能为空', trigger: 'blur' }
        ],
        postLevel:[
        { required: true, message: '岗位级别不能为空', trigger: 'change' }
        ]
      }
    }
  },
  computed: {
    postLevel() {
      return (id) => {
        return this.postLevelData.find(item => item.value == id)?.label;
      }
    }
  },
  created() {
    this.getList()
    this.getDeptTree()
  },
  methods: {
    /** 查询部门下拉树结构 */
    getDeptTree() {
      deptTreeSelect().then((response) => {
        this.deptOptions = response.data
      })
    },
    // 筛选节点
    filterNode(value, data) {
      if (!value) return true
      return data.label.indexOf(value) !== -1
    },
    // 节点单击事件
    handleNodeClick(data) {
      this.queryParams.deptId = data.id
      this.handleQuery()
    },
    /** 查询岗位列表 */
    getList() {
      this.loading = true
      listPost(this.queryParams).then((response) => {
        this.postList = response.rows
        this.total = response.total
        this.loading = false
      })
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        postId: undefined,
        postCode: undefined,
        postName: undefined,
        postSort: 0,
        importantType: 1,
        status: '0',
        remark: undefined
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.postId)
      this.single = selection.length != 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      if(!this.queryParams.deptId) {
        this.$modal.msgWarning('请先选择部门！！！')
        return
      }
      this.reset()
      this.open = true
      this.title = '添加岗位'
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset()
      const postId = row.postId || this.ids
      getPost(postId).then((response) => {
        this.form = response.data
        this.open = true
        this.title = '修改岗位'
      })
    },
    /** 提交按钮 */
    submitForm: function () {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          if (this.form.postId != undefined) {
            updatePost(this.form).then((response) => {
              this.$modal.msgSuccess('修改成功')
              this.open = false
              this.getList()
            })
          } else {
            addPost({...this.form, deptId: this.queryParams.deptId}).then((response) => {
              this.$modal.msgSuccess('新增成功')
              this.open = false
              this.getList()
            })
          }
        }
      })
    },
    // 上传格式校验
    beforeUpload(file) {
      const end = file.name.split('.')[file.name.split('.').length - 1]
      if (!this.whiteList.includes(end)) {
        this.$message.error('文件格式错误')
        return false
      }
      return true
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const postIds = row.postId || this.ids
      this.$modal
        .confirm('是否确认删除岗位编号为"' + postIds + '"的数据项？')
        .then(function () {
          return delPost(postIds)
        })
        .then(() => {
          this.getList()
          this.$modal.msgSuccess('删除成功')
        })
        .catch(() => { })
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        'system/post/export',
        {
          ...this.queryParams
        },
        `post_${new Date().getTime()}.xlsx`
      )
    },
    // 导入证件文件取消按钮
    cancelCredent() {
      this.importWen = false
      this.fileList = []
      this.uploadList = []
      // 清除上传的文件数据
      this.$refs.upload.clearFiles()
    },
    handleDown(path) {
      getBase64({ path }).then((res) => {
        let wj = encodeURIComponent(res.msg)
        wj = decodeURIComponent(wj)
        const myBlob = this.dataURLtoBlob(wj)
        this.previewUrl = myBlob
        this.previewType = this.iconByType(
          path.split('.')[path.split('.').length - 1]
        )
        this.filename = this.getFileName(path)
        this.handleDownload()
      })
    },
    async confirmCredent() {
      if (this.uploadList.length === 0) return this.$message.error('文件必传')
      // 调用上传文件接口
      const  res  = await systemBatchImport(this.uploadList);
      if (res.code === 200) {
        this.$message.success('导入成功')
        // 清除校验记录
        this.$refs.upload.resetFields()
        this.importWen = false
        this.fileList = []
        this.uploadList = []
      }else {
        this.$message.error(res.msg)
        this.handleDown(res.data)
        // 清除校验记录
        this.importWen = false
        this.fileList = []
        this.uploadList = []
      }
    },
     // 复审导入的移出
     removeContractAttachment(file, fileList) {
      this.fileList = fileList
      this.uploadList =  this.uploadList.filter(item=>item !== file.response.fileName)
    },
    // 文件上传前
    async uploadHttpRequest1(response, file, fileList) {
      this.uploadList.push(response.fileName)
    },
    // 获取文件后缀名
    iconByType(filename) {
      return filename.substring(filename.lastIndexOf('.') + 1, filename.length)
    },
    // 获取文件名称
    getFileName(name) {
      // 如果是url那么取最后的名字 如果不是直接返回
      if (name.lastIndexOf('/') > -1) {
        return name.slice(name.lastIndexOf('/') + 1)
      } else {
        return name
      }
    },
    dataURLtoBlob(dataurl) {
      const arr = dataurl.split(',')
      const mime = arr[0].match(/:(.*?);/)[1]
      const bstr = atob(arr[1])
      let n = bstr.length
      const u8arr = new Uint8Array(n)
      // eslint-disable-next-line no-plusplus
      while (n--) {
        u8arr[n] = bstr.charCodeAt(n)
      }
      return new Blob([u8arr], { type: mime })
    },
    handleDownload() {
      // 生成地址
      var myUrl = URL.createObjectURL(this.previewUrl)

      // 下载文件
      this.downloadFile(myUrl, this.filename)
    },
    downloadFile(url, name) {
      const a = document.createElement('a')
      a.setAttribute('href', url)
      a.setAttribute('download', name)
      a.setAttribute('target', '_blank')
      const clickEvent = document.createEvent('MouseEvents')
      clickEvent.initEvent('click', true, true)
      a.dispatchEvent(clickEvent)
    }
  }
}
</script>
